class ExampleModel extends Backbone.Model {
  url() {
    return
  }

  // Fake this up just for the demo. None of this is _actually required_ in a
  // real app using real Backbone and a real API
  sync() {
    const simulateResponse = () => {
      if(this.validateName.bind(this)()) {
        this.trigger('error', this, {
          responseJSON: {
            errors: {
              name: [this.validateName.bind(this)()],
            },
          },
        })
      } else {
        this.trigger('sync')
      }
    }

    this.trigger('request')
    setTimeout(simulateResponse, 1000)
  }

  validateName() {
    if(_.isEmpty(this.get('name'))) {
      return 'is required'
    }
  }
}

Rev.registerExample('ModelForm', class ModelFormExample extends React.Component {
  constructor(props) {
    super(props)

    this.state = {
      model: new ExampleModel(),
    }

    this.modelUpdated = () => this.forceUpdate()
  }

  componentDidMount() {
    this.state.model.on('all', this.modelUpdated)
  }

  componentWillUnmount() {
    this.state.model.off('all', this.modelUpdated)
  }

  render() {
    const {Row, Col, ModelForm, ModelProgressIndicator, ModelInput} = Rev.Components

    return (
      <div>
        <div>
          {JSON.stringify(this.state.model.attributes)}
        </div>
        <ModelForm model={this.state.model}>
          <Row>
            <Col>
              <ModelProgressIndicator model={this.state.model} started={'Click "Try it out"'} requested="Saving…" errored="ERROR ERROR" synced="Model saved!" />
            </Col>
          </Row>
          <Row>
            <Col><ModelInput field="name" type="text" placeholder="This field is required" model={this.state.model} /></Col>
            <Col><ModelInput field="optional" type="text" placeholder="This field is optional" model={this.state.model} /></Col>
            <Col><ModelInput field="textarea" type="textarea" model={this.state.model} /></Col>
            <Col>
              <ModelInput field="select" type="select" model={this.state.model}>
                <option></option>
                <option value="option1">Option 1</option>
                <option value="option2">Option 2</option>
              </ModelInput>
            </Col>
            <Col><button>Try it out</button></Col>
          </Row>
        </ModelForm>
      </div>
    )
  }
})
