class ExampleRow extends React.Component {
  render() {
    const {ModelInput} = Rev.Components

    return <div><ModelInput model={this.props.model} field="name" /></div>
  }
}

class ExampleControls extends React.Component {
  render() {
    return <button onClick={this.addOne.bind(this)}>+</button>
  }

  addOne(e) {
    e.preventDefault()
    this.props.items.add({})
  }
}

class EchoModel extends Backbone.Model {
  get urlRoot() {
    return '/echo'
  }

  sync() {
    this.trigger('sync')
  }
}

Rev.registerExample('ModelHasManyInput', class ModelHasManyInputExample extends React.Component {

  static get mixins() {
    return [Backbone.Events]
  }

  constructor(props) {
    super(props)

    this.state = {
      model: new EchoModel(),
    }
  }

  render() {
    const {ModelForm, ModelHasManyInput} = Rev.Components

    return (
      <ModelForm model={this.state.model}>
        Model JSON: {JSON.stringify(this.state.model.attributes)}
        <ModelHasManyInput
          model={this.state.model}
          field="rows"
          rowComponentClass={ExampleRow}
          controlComponentClass={ExampleControls}
        />
        <button>Submit</button>
      </ModelForm>
    )
  }

  onChange() {
    this.forceUpdate()
  }

  componentDidMount() {
    this.listenTo(this.state.model, 'all', this.onChange.bind(this))
  }

  componentWillUnmount() {
    this.stopListening()
  }
})
